/**
 * @module flitter-orm/src/schema/types/Model
 */

const ObjectType = require('./Object')

/**
 * Schema type representing an embedded model.
 * @extends module:flitter-orm/src/schema/types/Object
 */
class ModelType extends ObjectType {
    /**
     * Checks if an item can be cast to an object.
     * @param {*} val
     * @returns {boolean}
     */
    static validate(val) {
        return typeof val === 'object'
    }

    /**
     * Casts a value to an object.
     * @param {*} value
     * @returns {*}
     */
    static cast(val) {
        return val
    }
}

module.exports = exports = ModelType
