const { expect } = require('chai')
const { Injectable } = require('flitter-di')

const ResultCache = require('../../src/model/ResultCache')

describe('the query result cache', function() {
    let rc
    beforeEach(function() {
        rc = new ResultCache()
    })

    it('should be a functional class', function() {
        expect(ResultCache).to.be.a('function')
        expect(rc).to.be.an.instanceof(ResultCache)
        expect(rc).to.be.an.instanceof(Injectable)
    })

    it('should store, identify, and retrieve results', function() {
        class FakeModel {}
        class BadFakeModel {}
        const fake_id = 'some_fake_identifier_string'
        const result = {}

        rc.store(FakeModel, fake_id, result)

        expect(rc.has(FakeModel, fake_id)).to.be.true
        expect(rc.has(BadFakeModel, fake_id)).to.be.false
        expect(rc.has(FakeModel, 'bad fake id')).to.be.false
        expect(rc.has(BadFakeModel, 'bad fake id')).to.be.false

        expect(rc.get(FakeModel, fake_id)).to.be.equal(result)
    })
})
